local mPhotonView,mJavaBridge = ...


local ViewUtils    = nil
local hasReport    = nil
local mainLayout   = nil

function init()
    ViewUtils             = luajava.bindClass('com.tencent.assistant.utils.ViewUtils')
    mainLayout            = mPhotonView:getParser():getChildView("main_layout")
    class1                = mPhotonView:getParser():getChildView("class1")
    class2                = mPhotonView:getParser():getChildView("class2")
    class3                = mPhotonView:getParser():getChildView("class3")
    class4                = mPhotonView:getParser():getChildView("class4")

    local background1    = luajava.newInstance('android.graphics.drawable.GradientDrawable')
    local background2    = luajava.newInstance('android.graphics.drawable.GradientDrawable')
    local background3    = luajava.newInstance('android.graphics.drawable.GradientDrawable')
    local background4    = luajava.newInstance('android.graphics.drawable.GradientDrawable')
    
    local Color                 = luajava.bindClass('android.graphics.Color') 

    
    background1:setCornerRadius(mJavaBridge:dip2px(3))
    background1:setColor(Color:parseColor("#1d82ff"))
    class1:getView():setBackgroundDrawable(background1)
    
    background2:setCornerRadius(mJavaBridge:dip2px(3))
    background2:setColor(Color:parseColor("#fc5648"))
    class2:getView():setBackgroundDrawable(background2)

    background3:setCornerRadius(mJavaBridge:dip2px(3))
    background3:setColor(Color:parseColor("#46c800"))
    class3:getView():setBackgroundDrawable(background3)

    background4:setCornerRadius(mJavaBridge:dip2px(3))
    background4:setColor(Color:parseColor("#f2b408"))
    class4:getView():setBackgroundDrawable(background4)

end


function refreshTitle()
    local binder          = mPhotonView:getParser():getBinder()
    local allJump         = mPhotonView:getParser():getBinder():get("card_click_jump")

    if (allJump == nil or allJump == "null") then
        local allview = mPhotonView:getParser():getChildView("more_text")
        allview:getParser():update("visibility","gone")
    end
    local cardPosition = binder:get("fixPosition")
    local newSlotId = "98_00"..(tonumber(cardPosition) + 1)
    binder:update("newSlotId",newSlotId)



end

function report()
    local cardPosition =  mPhotonView:getParser():getBinder():get("fixPosition")
    local slotId = "98_00"..(tonumber(cardPosition) + 1)
    local reportPara = "slotid:"..slotId..",actionid:200,subposition:-1,scene:2001,status:0,modeltype:9042,recommendid:data@R1"
    reportApp(reportPara)
end


function reportApp(param)
    local data ={}
    data["param"]=param
    mPhotonView:getParser():getTaskCenter():getActionRunner():run("reportaction",data,data)
end
